; Digital Alarm Clock from the MK14 Manual

	CPU	SC/MP

CROM	EQU	0x010B			; Segment table in SCIOS
DISP	EQU	0x0D00			; Display

ROW	EQU	0x0F10

	ORG	0x0F12
	DB	0			; Alarm hours
	DB	0			; Alarm mins
	DB	0			; Alarm secs
	DB	0			; Not used
TIM	DB	0x12			; Hours
	DB	0			; Mins
	DB	0			; Seconds
	DB	0
	DB	0x76			; 24 hours (bump up)
	DB	0x40			; 60 mins
	DB	0x40			; 60 seconds
SPEED	DB	0x20			; Display cycles/second (80)

	ORG	0x0F20
CLOCK	LDI	CROM >> 8		; P3 points to segment table
	XPAH	P3
	LDI	CROM & 0x00FF
	XPAL	P3
;
; This basic loop has been cycle trimmed for 12.5msec on 4MHz SC/MP
; This makes for a dim if precise display!
;
NEW	LDI	(DISP+0x0D) >> 8	; P2 points just before display
	XPAH	P2			; Three invisible digits are
	LDI	(DISP+0x0D) & 0x00FF	;  written to display
	XPAL	P2
	LDI	(TIM+4) >> 8
	XPAH	P1
	LDI	(TIM+4) & 0x00FF
	XPAL	P1
	SCL				; Ensure first digit increments
	LDI	5			; Display field loop counter
	ST	ROW
AGAIN	LD	@-1(P1)			; Increment digit pair
	DAI	0
	ST	0(P1)
	DAD	4(P1)			; Bump up
	JZ	CS			; Zero means roll-over
	JZ	CS			; (Equalise cycles)
	JMP	CONT
CS	ST	0(P1)			; Roll over - reset to zero NB. CY/L is set
CONT	LD	0(P1)			; Display digit pair
	ANI	0x0F
	XAE
	LD	-128(P3)
	ST	@1(P2)
	LDI	0x40
	DLY	0
	LD	0(P1)
	SR
	SR
	SR
	SR
	XAE
	LD	-128(P3)
	ST	@2(P2)			; Leave a gap.
	DLD	ROW			; Next digit pair.
	JNZ	AGAIN
	LDI	3			; Prepare for alarm loop
	ST	ROW
	LDI	0
	XAE
LOOP	LD	@-1(P1)			; Compare digit pair.
	XOR	4(P1)			; Zero here means same
	ORE				; Or 'em all up!
	XAE				; Keep OR-up in EXT
	DLD	ROW
	JNZ	LOOP
	XAE				; Check final result.
	JZ	ALARM			; Zero means alarm time!
	LDE
	JMP	CONTIN			; Select 0 or 7 here
ALARM	LDI	0x07
	NOP
CONTIN	CAS				; Raise F0, F1 and F2 if alarm
	LDI	37			;  time
	DLY	19
	JMP	NEW

	END
